// Copyright 2021 The Pigweed Authors
//
// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy of
// the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations under
// the License.

#include "pw_board_led/led.h"

#include <Arduino.h>

#include <cinttypes>

namespace pw::board_led {
namespace {

bool led_on = false;

}  // namespace

void Init() {
  pinMode(LED_BUILTIN, OUTPUT);
  TurnOff();
}

void TurnOff() {
  digitalWrite(LED_BUILTIN, LOW);
  led_on = false;
}

void TurnOn() {
  digitalWrite(LED_BUILTIN, HIGH);
  led_on = true;
}

void Toggle() {
  // Check if the LED is on. If so, turn it off.
  if (led_on) {
    TurnOff();
  } else {
    TurnOn();
  }
}

}  // namespace pw::board_led
